##// END OF EJS Templates
a
Unknown -
r483:d45b47961ecd
parent child
Show More
@@ -1,273 +1,275
1 #
1 #
2 # Setup RPi2/3 config and cmdline
2 # Setup RPi2/3 config and cmdline
3 #
3 #
4
4
5 # Load utility functions
5 # Load utility functions
6 . ./functions.sh
6 . ./functions.sh
7
7
8 #if [ "$BUILD_KERNEL" = true ] ; then
8 #if [ "$BUILD_KERNEL" = true ] ; then
9 if [ -n "$RPI_FIRMWARE_DIR" ] && [ -d "$RPI_FIRMWARE_DIR" ] ; then
9 if [ -n "$RPI_FIRMWARE_DIR" ] && [ -d "$RPI_FIRMWARE_DIR" ] ; then
10 # Install boot binaries from local directory
10 # Install boot binaries from local directory
11 cp "${RPI_FIRMWARE_DIR}"/boot/bootcode.bin "${BOOT_DIR}"/bootcode.bin
11 cp "${RPI_FIRMWARE_DIR}"/boot/bootcode.bin "${BOOT_DIR}"/bootcode.bin
12 cp "${RPI_FIRMWARE_DIR}"/boot/fixup.dat "${BOOT_DIR}"/fixup.dat
12 cp "${RPI_FIRMWARE_DIR}"/boot/fixup.dat "${BOOT_DIR}"/fixup.dat
13 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_cd.dat "${BOOT_DIR}"/fixup_cd.dat
13 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_cd.dat "${BOOT_DIR}"/fixup_cd.dat
14 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_x.dat "${BOOT_DIR}"/fixup_x.dat
14 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_x.dat "${BOOT_DIR}"/fixup_x.dat
15 cp "${RPI_FIRMWARE_DIR}"/boot/start.elf "${BOOT_DIR}"/start.elf
15 cp "${RPI_FIRMWARE_DIR}"/boot/start.elf "${BOOT_DIR}"/start.elf
16 cp "${RPI_FIRMWARE_DIR}"/boot/start_cd.elf "${BOOT_DIR}"/start_cd.elf
16 cp "${RPI_FIRMWARE_DIR}"/boot/start_cd.elf "${BOOT_DIR}"/start_cd.elf
17 cp "${RPI_FIRMWARE_DIR}"/boot/start_x.elf "${BOOT_DIR}"/start_x.elf
17 cp "${RPI_FIRMWARE_DIR}"/boot/start_x.elf "${BOOT_DIR}"/start_x.elf
18 else
18 else
19 # Create temporary directory for boot binaries
19 # Create temporary directory for boot binaries
20 temp_dir=$(as_nobody mktemp -d)
20 temp_dir=$(as_nobody mktemp -d)
21
21
22 # Install latest boot binaries from raspberry/firmware github
22 # Install latest boot binaries from raspberry/firmware github
23 as_nobody wget -q -O "${temp_dir}/bootcode.bin" "${FIRMWARE_URL}/bootcode.bin"
23 as_nobody wget -q -O "${temp_dir}/bootcode.bin" "${FIRMWARE_URL}/bootcode.bin"
24 as_nobody wget -q -O "${temp_dir}/fixup.dat" "${FIRMWARE_URL}/fixup.dat"
24 as_nobody wget -q -O "${temp_dir}/fixup.dat" "${FIRMWARE_URL}/fixup.dat"
25 as_nobody wget -q -O "${temp_dir}/fixup_cd.dat" "${FIRMWARE_URL}/fixup_cd.dat"
25 as_nobody wget -q -O "${temp_dir}/fixup_cd.dat" "${FIRMWARE_URL}/fixup_cd.dat"
26 as_nobody wget -q -O "${temp_dir}/fixup_x.dat" "${FIRMWARE_URL}/fixup_x.dat"
26 as_nobody wget -q -O "${temp_dir}/fixup_x.dat" "${FIRMWARE_URL}/fixup_x.dat"
27 as_nobody wget -q -O "${temp_dir}/start.elf" "${FIRMWARE_URL}/start.elf"
27 as_nobody wget -q -O "${temp_dir}/start.elf" "${FIRMWARE_URL}/start.elf"
28 as_nobody wget -q -O "${temp_dir}/start_cd.elf" "${FIRMWARE_URL}/start_cd.elf"
28 as_nobody wget -q -O "${temp_dir}/start_cd.elf" "${FIRMWARE_URL}/start_cd.elf"
29 as_nobody wget -q -O "${temp_dir}/start_x.elf" "${FIRMWARE_URL}/start_x.elf"
29 as_nobody wget -q -O "${temp_dir}/start_x.elf" "${FIRMWARE_URL}/start_x.elf"
30
30
31 # Move downloaded boot binaries
31 # Move downloaded boot binaries
32 mv "${temp_dir}/"* "${BOOT_DIR}/"
32 mv "${temp_dir}/"* "${BOOT_DIR}/"
33
33
34 # Remove temporary directory for boot binaries
34 # Remove temporary directory for boot binaries
35 rm -fr "${temp_dir}"
35 rm -fr "${temp_dir}"
36
36
37 # Set permissions of the boot binaries
37 # Set permissions of the boot binaries
38 chown -R root:root "${BOOT_DIR}"
38 chown -R root:root "${BOOT_DIR}"
39 chmod -R 600 "${BOOT_DIR}"
39 chmod -R 600 "${BOOT_DIR}"
40 fi
40 fi
41 #fi
41 #fi
42
42
43 # Setup firmware boot cmdline
43 # Setup firmware boot cmdline
44 if [ "$ENABLE_UBOOTUSB" = true ] ; then
44 if [ "$ENABLE_UBOOTUSB" = true ] ; then
45 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
45 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
46 else
46 else
47 if [ "$ENABLE_SPLITFS" = true ] ; then
47 if [ "$ENABLE_SPLITFS" = true ] ; then
48 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda1 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
48 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda1 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
49 else
49 else
50 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/mmcblk0p2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
50 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/mmcblk0p2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
51 fi
51 fi
52 fi
52 fi
53
53
54 # Add encrypted root partition to cmdline.txt
54 # Add encrypted root partition to cmdline.txt
55 if [ "$ENABLE_CRYPTFS" = true ] ; then
55 if [ "$ENABLE_CRYPTFS" = true ] ; then
56 if [ "$ENABLE_SPLITFS" = true ] ; then
56 if [ "$ENABLE_SPLITFS" = true ] ; then
57 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda1/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda1:${CRYPTFS_MAPPING}/")
57 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda1/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda1:${CRYPTFS_MAPPING}/")
58 else
58 else
59 if [ "$ENABLE_UBOOTUSB" = true ] ; then
59 if [ "$ENABLE_UBOOTUSB" = true ] ; then
60 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda2:${CRYPTFS_MAPPING}/")
60 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda2:${CRYPTFS_MAPPING}/")
61 else
61 else
62 CMDLINE=$(echo "${CMDLINE}" | sed "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/mmcblk0p2:${CRYPTFS_MAPPING}/")
62 CMDLINE=$(echo "${CMDLINE}" | sed "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/mmcblk0p2:${CRYPTFS_MAPPING}/")
63 fi
63 fi
64 fi
64 fi
65 fi
65 fi
66
66
67 if [ "$ENABLE_PRINTK" = true ] ; then
67 if [ "$ENABLE_PRINTK" = true ] ; then
68 install_readonly files/sysctl.d/83-rpi-printk.conf "${ETC_DIR}/sysctl.d/83-rpi-printk.conf"
68 install_readonly files/sysctl.d/83-rpi-printk.conf "${ETC_DIR}/sysctl.d/83-rpi-printk.conf"
69 fi
69 fi
70
70
71 # Install udev rule for serial alias - serial0 = console serial1=bluetooth
71 # Install udev rule for serial alias - serial0 = console serial1=bluetooth
72 install_readonly files/etc/99-com.rules "${LIB_DIR}/udev/rules.d/99-com.rules"
72 install_readonly files/etc/99-com.rules "${LIB_DIR}/udev/rules.d/99-com.rules"
73
73
74 # Remove IPv6 networking support
74 # Remove IPv6 networking support
75 if [ "$ENABLE_IPV6" = false ] ; then
75 if [ "$ENABLE_IPV6" = false ] ; then
76 CMDLINE="${CMDLINE} ipv6.disable=1"
76 CMDLINE="${CMDLINE} ipv6.disable=1"
77 fi
77 fi
78
78
79 # Automatically assign predictable network interface names
79 # Automatically assign predictable network interface names
80 if [ "$ENABLE_IFNAMES" = false ] ; then
80 if [ "$ENABLE_IFNAMES" = false ] ; then
81 CMDLINE="${CMDLINE} net.ifnames=0"
81 CMDLINE="${CMDLINE} net.ifnames=0"
82 else
82 else
83 CMDLINE="${CMDLINE} net.ifnames=1"
83 CMDLINE="${CMDLINE} net.ifnames=1"
84 fi
84 fi
85
85
86 # Install firmware config
86 # Install firmware config
87 install_readonly files/boot/config.txt "${BOOT_DIR}/config.txt"
87 install_readonly files/boot/config.txt "${BOOT_DIR}/config.txt"
88
88
89 #locks cpu at max frequency
89 #locks cpu at max frequency
90 if [ "$ENABLE_TURBO" = true ] ; then
90 if [ "$ENABLE_TURBO" = true ] ; then
91 echo "force_turbo=1" >> "${BOOT_DIR}/config.txt"
91 echo "force_turbo=1" >> "${BOOT_DIR}/config.txt"
92 # helps to avoid sdcard corruption when force_turbo is enabled.
92 # helps to avoid sdcard corruption when force_turbo is enabled.
93 echo "boot_delay=1" >> "${BOOT_DIR}/config.txt"
93 echo "boot_delay=1" >> "${BOOT_DIR}/config.txt"
94 fi
94 fi
95
95
96 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
96 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
97
97
98 # Bluetooth enabled
98 # Bluetooth enabled
99 if [ "$ENABLE_BLUETOOTH" = true ] ; then
99 if [ "$ENABLE_BLUETOOTH" = true ] ; then
100 # Create temporary directory for Bluetooth sources
100 # Create temporary directory for Bluetooth sources
101 temp_dir=$(as_nobody mktemp -d)
101 temp_dir=$(as_nobody mktemp -d)
102
102
103 # Fetch Bluetooth sources
103 # Fetch Bluetooth sources
104 as_nobody git -C "${temp_dir}" clone "${BLUETOOTH_URL}"
104 as_nobody git -C "${temp_dir}" clone "${BLUETOOTH_URL}"
105
105
106 # Copy downloaded sources
106 # Copy downloaded sources
107 mv "${temp_dir}/pi-bluetooth" "${R}/tmp/"
107 mv "${temp_dir}/pi-bluetooth" "${R}/tmp/"
108
108
109 # Bluetooth firmware from arch aur https://aur.archlinux.org/packages/pi-bluetooth/
109 # Bluetooth firmware from arch aur https://aur.archlinux.org/packages/pi-bluetooth/
110 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" https://aur.archlinux.org/cgit/aur.git/plain/LICENCE.broadcom_bcm43xx?h=pi-bluetooth
110 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" https://aur.archlinux.org/cgit/aur.git/plain/LICENCE.broadcom_bcm43xx?h=pi-bluetooth
111 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" https://aur.archlinux.org/cgit/aur.git/plain/BCM43430A1.hcd?h=pi-bluetooth
111 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" https://aur.archlinux.org/cgit/aur.git/plain/BCM43430A1.hcd?h=pi-bluetooth
112
112
113 # Set permissions
113 # Set permissions
114 chown -R root:root "${R}/tmp/pi-bluetooth"
114 chown -R root:root "${R}/tmp/pi-bluetooth"
115
115
116 # Install tools
116 # Install tools
117 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/btuart" "${R}/usr/bin/btuart"
117 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/btuart" "${R}/usr/bin/btuart"
118 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/bthelper" "${R}/usr/bin/bthelper"
118 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/bthelper" "${R}/usr/bin/bthelper"
119
120 # make scripts executable
119 chmod +x "${R}/usr/bin/bthelper"
121 chmod +x "${R}/usr/bin/bthelper"
120 chmod +x "${R}/usr/bin/btuart"
122 chmod +x "${R}/usr/bin/btuart"
121
123
122 # Install bluetooth udev rule
124 # Install bluetooth udev rule
123 install_readonly "${R}/tmp/pi-bluetooth/lib/udev/rules.d/90-pi-bluetooth.rules" "${LIB_DIR}/udev/rules.d/90-pi-bluetooth.rules"
125 install_readonly "${R}/tmp/pi-bluetooth/lib/udev/rules.d/90-pi-bluetooth.rules" "${LIB_DIR}/udev/rules.d/90-pi-bluetooth.rules"
124
126
125 # Install Firmware Flash file and apropiate licence
127 # Install Firmware Flash file and apropiate licence
126 mkdir -p "$BLUETOOTH_FIRMWARE_DIR"
128 mkdir -p "$BLUETOOTH_FIRMWARE_DIR"
127 install_readonly "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
129 install_readonly "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
128 install_readonly "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
130 install_readonly "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
129 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.bthelper@.service" "${ETC_DIR}/systemd/system/pi-bluetooth.bthelper@.service"
131 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.bthelper@.service" "${ETC_DIR}/systemd/system/pi-bluetooth.bthelper@.service"
130 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.hciuart.service" "${ETC_DIR}/systemd/system/pi-bluetooth.hciuart.service"
132 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.hciuart.service" "${ETC_DIR}/systemd/system/pi-bluetooth.hciuart.service"
131
133
132 # Remove temporary directories
134 # Remove temporary directories
133 rm -fr "${temp_dir}"
135 rm -fr "${temp_dir}"
134 rm -fr "${R}"/tmp/pi-bluetooth
136 rm -fr "${R}"/tmp/pi-bluetooth
135
137
136 # Switch Pi3 Bluetooth function to use the mini-UART (ttyS0) and restore UART0/ttyAMA0 over GPIOs 14 & 15. Slow Bluetooth and slow cpu. Use /dev/ttyS0 instead of /dev/ttyAMA0
138 # Switch Pi3 Bluetooth function to use the mini-UART (ttyS0) and restore UART0/ttyAMA0 over GPIOs 14 & 15. Slow Bluetooth and slow cpu. Use /dev/ttyS0 instead of /dev/ttyAMA0
137 if [ "$ENABLE_MINIUART_OVERLAY" = true ] ; then
139 if [ "$ENABLE_MINIUART_OVERLAY" = true ] ; then
138
140
139 # set overlay to swap ttyAMA0 and ttyS0
141 # set overlay to swap ttyAMA0 and ttyS0
140 echo "dtoverlay=pi3-miniuart-bt" >> "${BOOT_DIR}/config.txt"
142 echo "dtoverlay=pi3-miniuart-bt" >> "${BOOT_DIR}/config.txt"
141
143
142 # if force_turbo didn't lock cpu at high speed, lock it at low speed (XOR logic) or miniuart will be broken
144 # if force_turbo didn't lock cpu at high speed, lock it at low speed (XOR logic) or miniuart will be broken
143 if [ "$ENABLE_TURBO" = false ] ; then
145 if [ "$ENABLE_TURBO" = false ] ; then
144 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
146 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
145 fi
147 fi
146 fi
148 fi
147
149
148 # Activate services
150 # Activate services
149 chroot_exec systemctl enable pi-bluetooth.hciuart.service
151 chroot_exec systemctl enable pi-bluetooth.hciuart.service
150 chroot_exec systemctl enable pi-bluetooth.bthelper@serial1.service
152 chroot_exec systemctl enable pi-bluetooth.bthelper@serial1.service
151
153
152 else # if ENABLE_BLUETOOTH = false
154 else # if ENABLE_BLUETOOTH = false
153 # set overlay to disable bluetooth
155 # set overlay to disable bluetooth
154 echo "dtoverlay=pi3-disable-bt" >> "${BOOT_DIR}/config.txt"
156 echo "dtoverlay=pi3-disable-bt" >> "${BOOT_DIR}/config.txt"
155 fi # ENABLE_BLUETOOTH end
157 fi # ENABLE_BLUETOOTH end
156 fi
158 fi
157
159
158 # may need sudo systemctl disable hciuart
160 # may need sudo systemctl disable hciuart
159 if [ "$ENABLE_CONSOLE" = true ] ; then
161 if [ "$ENABLE_CONSOLE" = true ] ; then
160 echo "enable_uart=1" >> "${BOOT_DIR}/config.txt"
162 echo "enable_uart=1" >> "${BOOT_DIR}/config.txt"
161 # add string to cmdline
163 # add string to cmdline
162 CMDLINE="${CMDLINE} console=serial0,115200"
164 CMDLINE="${CMDLINE} console=serial0,115200"
163
165
164 # Enable serial console systemd style
166 # Enable serial console systemd style
165 chroot_exec systemctl enable serial-getty@serial0.service
167 chroot_exec systemctl enable serial-getty@serial0.service
166 else
168 else
167 echo "enable_uart=0" >> "${BOOT_DIR}/config.txt"
169 echo "enable_uart=0" >> "${BOOT_DIR}/config.txt"
168 # disable serial console systemd style
170 # disable serial console systemd style
169 #chroot_exec systemctl disable serial-getty@serial0.service
171 #chroot_exec systemctl disable serial-getty@serial0.service
170 fi
172 fi
171
173
172 # Remove cmdline.txt entry of starting zswap
174 # Remove cmdline.txt entry of starting zswap
173 if [ "$KERNEL_ZSWAP" = true ] ; then
175 if [ "$KERNEL_ZSWAP" = true ] ; then
174 CMDLINE="${CMDLINE} zswap.enabled=1 zswap.max_pool_percent=25 zswap.compressor=lz4"
176 CMDLINE="${CMDLINE} zswap.enabled=1 zswap.max_pool_percent=25 zswap.compressor=lz4"
175 fi
177 fi
176
178
177 if [ "$ENABLE_SYSTEMDSWAP" = true ] ; then
179 if [ "$ENABLE_SYSTEMDSWAP" = true ] ; then
178
180
179 # Remove cmdline.txt entry of starting zswap
181 # Remove cmdline.txt entry of starting zswap
180 if [ "$KERNEL_ZSWAP" = true ] ; then
182 if [ "$KERNEL_ZSWAP" = true ] ; then
181 sed -i 's|zswap.enabled=1 zswap.max_pool_percent=25 zswap.compressor=lz4||g'
183 sed -i 's|zswap.enabled=1 zswap.max_pool_percent=25 zswap.compressor=lz4||g'
182 fi
184 fi
183 # Create temporary directory for systemd-swap sources
185 # Create temporary directory for systemd-swap sources
184 temp_dir=$(as_nobody mktemp -d)
186 temp_dir=$(as_nobody mktemp -d)
185
187
186 # Fetch systemd-swap sources
188 # Fetch systemd-swap sources
187 as_nobody git -C "${temp_dir}" clone "${ZSWAP_URL}"
189 as_nobody git -C "${temp_dir}" clone "${ZSWAP_URL}"
188
190
189 # Copy downloaded systemd-swap sources
191 # Copy downloaded systemd-swap sources
190 mv "${temp_dir}/systemd-swap" "${R}/tmp/"
192 mv "${temp_dir}/systemd-swap" "${R}/tmp/"
191
193
192 # Set permissions of the systemd-swap sources
194 # Set permissions of the systemd-swap sources
193 chown -R root:root "${R}/tmp/systemd-swap"
195 chown -R root:root "${R}/tmp/systemd-swap"
194
196
195 # Remove temporary directory for systemd-swap sources
197 # Remove temporary directory for systemd-swap sources
196 rm -fr "${temp_dir}"
198 rm -fr "${temp_dir}"
197
199
198 # Change into downloaded src dir
200 # Change into downloaded src dir
199 cd "${R}/tmp/systemd-swap" || exit
201 cd "${R}/tmp/systemd-swap" || exit
200
202
201 # Build package
203 # Build package
202 . ./systemd-swap/package.sh debian
204 . ./systemd-swap/package.sh debian
203
205
204 # Install package
206 # Install package
205 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap-*any.deb
207 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap-*any.deb
206
208
207 # Enable service
209 # Enable service
208 chroot_exec systemctl enable systemd-swap
210 chroot_exec systemctl enable systemd-swap
209
211
210 # Change back into script root dir
212 # Change back into script root dir
211 cd "${WORKDIR}" || exit
213 cd "${WORKDIR}" || exit
212 fi
214 fi
213
215
214 # Install firmware boot cmdline
216 # Install firmware boot cmdline
215 echo "${CMDLINE}" > "${BOOT_DIR}/cmdline.txt"
217 echo "${CMDLINE}" > "${BOOT_DIR}/cmdline.txt"
216
218
217 # Setup minimal GPU memory allocation size: 16MB (no X)
219 # Setup minimal GPU memory allocation size: 16MB (no X)
218 if [ "$ENABLE_MINGPU" = true ] ; then
220 if [ "$ENABLE_MINGPU" = true ] ; then
219 echo "gpu_mem=16" >> "${BOOT_DIR}/config.txt"
221 echo "gpu_mem=16" >> "${BOOT_DIR}/config.txt"
220 fi
222 fi
221
223
222 # Setup boot with initramfs
224 # Setup boot with initramfs
223 if [ "$ENABLE_INITRAMFS" = true ] ; then
225 if [ "$ENABLE_INITRAMFS" = true ] ; then
224 echo "initramfs initramfs-${KERNEL_VERSION} followkernel" >> "${BOOT_DIR}/config.txt"
226 echo "initramfs initramfs-${KERNEL_VERSION} followkernel" >> "${BOOT_DIR}/config.txt"
225 fi
227 fi
226
228
227 # Create firmware configuration and cmdline symlinks
229 # Create firmware configuration and cmdline symlinks
228 ln -sf firmware/config.txt "${R}/boot/config.txt"
230 ln -sf firmware/config.txt "${R}/boot/config.txt"
229 ln -sf firmware/cmdline.txt "${R}/boot/cmdline.txt"
231 ln -sf firmware/cmdline.txt "${R}/boot/cmdline.txt"
230
232
231 # Install and setup kernel modules to load at boot
233 # Install and setup kernel modules to load at boot
232 mkdir -p "${LIB_DIR}/modules-load.d/"
234 mkdir -p "${LIB_DIR}/modules-load.d/"
233 install_readonly files/modules/rpi2.conf "${LIB_DIR}/modules-load.d/rpi2.conf"
235 install_readonly files/modules/rpi2.conf "${LIB_DIR}/modules-load.d/rpi2.conf"
234
236
235 # Load hardware random module at boot
237 # Load hardware random module at boot
236 if [ "$ENABLE_HWRANDOM" = true ] && [ "$BUILD_KERNEL" = false ] ; then
238 if [ "$ENABLE_HWRANDOM" = true ] && [ "$BUILD_KERNEL" = false ] ; then
237 sed -i "s/^# bcm2708_rng/bcm2708_rng/" "${LIB_DIR}/modules-load.d/rpi2.conf"
239 sed -i "s/^# bcm2708_rng/bcm2708_rng/" "${LIB_DIR}/modules-load.d/rpi2.conf"
238 fi
240 fi
239
241
240 # Load sound module at boot
242 # Load sound module at boot
241 if [ "$ENABLE_SOUND" = true ] ; then
243 if [ "$ENABLE_SOUND" = true ] ; then
242 sed -i "s/^# snd_bcm2835/snd_bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
244 sed -i "s/^# snd_bcm2835/snd_bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
243 else
245 else
244 echo "dtparam=audio=off" >> "${BOOT_DIR}/config.txt"
246 echo "dtparam=audio=off" >> "${BOOT_DIR}/config.txt"
245 fi
247 fi
246
248
247 # Enable I2C interface
249 # Enable I2C interface
248 if [ "$ENABLE_I2C" = true ] ; then
250 if [ "$ENABLE_I2C" = true ] ; then
249 echo "dtparam=i2c_arm=on" >> "${BOOT_DIR}/config.txt"
251 echo "dtparam=i2c_arm=on" >> "${BOOT_DIR}/config.txt"
250 sed -i "s/^# i2c-bcm2708/i2c-bcm2708/" "${LIB_DIR}/modules-load.d/rpi2.conf"
252 sed -i "s/^# i2c-bcm2708/i2c-bcm2708/" "${LIB_DIR}/modules-load.d/rpi2.conf"
251 sed -i "s/^# i2c-dev/i2c-dev/" "${LIB_DIR}/modules-load.d/rpi2.conf"
253 sed -i "s/^# i2c-dev/i2c-dev/" "${LIB_DIR}/modules-load.d/rpi2.conf"
252 fi
254 fi
253
255
254 # Enable SPI interface
256 # Enable SPI interface
255 if [ "$ENABLE_SPI" = true ] ; then
257 if [ "$ENABLE_SPI" = true ] ; then
256 echo "dtparam=spi=on" >> "${BOOT_DIR}/config.txt"
258 echo "dtparam=spi=on" >> "${BOOT_DIR}/config.txt"
257 echo "spi-bcm2708" >> "${LIB_DIR}/modules-load.d/rpi2.conf"
259 echo "spi-bcm2708" >> "${LIB_DIR}/modules-load.d/rpi2.conf"
258 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]; then
260 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]; then
259 sed -i "s/spi-bcm2708/spi-bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
261 sed -i "s/spi-bcm2708/spi-bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
260 fi
262 fi
261 fi
263 fi
262
264
263 # Disable RPi2/3 under-voltage warnings
265 # Disable RPi2/3 under-voltage warnings
264 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
266 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
265 echo "avoid_warnings=${DISABLE_UNDERVOLT_WARNINGS}" >> "${BOOT_DIR}/config.txt"
267 echo "avoid_warnings=${DISABLE_UNDERVOLT_WARNINGS}" >> "${BOOT_DIR}/config.txt"
266 fi
268 fi
267
269
268 # Install kernel modules blacklist
270 # Install kernel modules blacklist
269 mkdir -p "${ETC_DIR}/modprobe.d/"
271 mkdir -p "${ETC_DIR}/modprobe.d/"
270 install_readonly files/modules/raspi-blacklist.conf "${ETC_DIR}/modprobe.d/raspi-blacklist.conf"
272 install_readonly files/modules/raspi-blacklist.conf "${ETC_DIR}/modprobe.d/raspi-blacklist.conf"
271
273
272 # Install sysctl.d configuration files
274 # Install sysctl.d configuration files
273 install_readonly files/sysctl.d/81-rpi-vm.conf "${ETC_DIR}/sysctl.d/81-rpi-vm.conf"
275 install_readonly files/sysctl.d/81-rpi-vm.conf "${ETC_DIR}/sysctl.d/81-rpi-vm.conf"
@@ -1,867 +1,859
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47
47
48 # Kernel Branch
48 # Kernel Branch
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62
62
63 # Kernel deb packages for 32bit kernel
63 # Kernel deb packages for 32bit kernel
64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 # Default precompiled 64bit kernel
68 # Default precompiled 64bit kernel
69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 # Generic
70 # Generic
71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72
72
73 # Build directories
73 # Build directories
74 WORKDIR=$(pwd)
74 WORKDIR=$(pwd)
75 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
75 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
76 BUILDDIR="${BASEDIR}/build"
76 BUILDDIR="${BASEDIR}/build"
77
77
78 # Chroot directories
78 # Chroot directories
79 R="${BUILDDIR}/chroot"
79 R="${BUILDDIR}/chroot"
80 ETC_DIR="${R}/etc"
80 ETC_DIR="${R}/etc"
81 LIB_DIR="${R}/lib"
81 LIB_DIR="${R}/lib"
82 BOOT_DIR="${R}/boot/firmware"
82 BOOT_DIR="${R}/boot/firmware"
83 KERNEL_DIR="${R}/usr/src/linux"
83 KERNEL_DIR="${R}/usr/src/linux"
84 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
84 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
85 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
85 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
86
86
87 # Firmware directory: Blank if download from github
87 # Firmware directory: Blank if download from github
88 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
88 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
89
89
90 # General settings
90 # General settings
91 SET_ARCH=${SET_ARCH:=32}
91 SET_ARCH=${SET_ARCH:=32}
92 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
92 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
93 PASSWORD=${PASSWORD:=raspberry}
93 PASSWORD=${PASSWORD:=raspberry}
94 USER_PASSWORD=${USER_PASSWORD:=raspberry}
94 USER_PASSWORD=${USER_PASSWORD:=raspberry}
95 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
95 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
96 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
96 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
97 EXPANDROOT=${EXPANDROOT:=true}
97 EXPANDROOT=${EXPANDROOT:=true}
98
98
99 # Keyboard settings
99 # Keyboard settings
100 XKB_MODEL=${XKB_MODEL:=""}
100 XKB_MODEL=${XKB_MODEL:=""}
101 XKB_LAYOUT=${XKB_LAYOUT:=""}
101 XKB_LAYOUT=${XKB_LAYOUT:=""}
102 XKB_VARIANT=${XKB_VARIANT:=""}
102 XKB_VARIANT=${XKB_VARIANT:=""}
103 XKB_OPTIONS=${XKB_OPTIONS:=""}
103 XKB_OPTIONS=${XKB_OPTIONS:=""}
104
104
105 # Network settings (DHCP)
105 # Network settings (DHCP)
106 ENABLE_DHCP=${ENABLE_DHCP:=true}
106 ENABLE_DHCP=${ENABLE_DHCP:=true}
107
107
108 # Network settings (static)
108 # Network settings (static)
109 NET_ADDRESS=${NET_ADDRESS:=""}
109 NET_ADDRESS=${NET_ADDRESS:=""}
110 NET_GATEWAY=${NET_GATEWAY:=""}
110 NET_GATEWAY=${NET_GATEWAY:=""}
111 NET_DNS_1=${NET_DNS_1:=""}
111 NET_DNS_1=${NET_DNS_1:=""}
112 NET_DNS_2=${NET_DNS_2:=""}
112 NET_DNS_2=${NET_DNS_2:=""}
113 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
113 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
114 NET_NTP_1=${NET_NTP_1:=""}
114 NET_NTP_1=${NET_NTP_1:=""}
115 NET_NTP_2=${NET_NTP_2:=""}
115 NET_NTP_2=${NET_NTP_2:=""}
116
116
117 # APT settings
117 # APT settings
118 APT_PROXY=${APT_PROXY:=""}
118 APT_PROXY=${APT_PROXY:=""}
119 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
119 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
120
120
121 # Feature settings
121 # Feature settings
122 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
122 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
123 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
123 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
124 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
124 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
125 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
125 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
126 ENABLE_I2C=${ENABLE_I2C:=false}
126 ENABLE_I2C=${ENABLE_I2C:=false}
127 ENABLE_SPI=${ENABLE_SPI:=false}
127 ENABLE_SPI=${ENABLE_SPI:=false}
128 ENABLE_IPV6=${ENABLE_IPV6:=true}
128 ENABLE_IPV6=${ENABLE_IPV6:=true}
129 ENABLE_SSHD=${ENABLE_SSHD:=true}
129 ENABLE_SSHD=${ENABLE_SSHD:=true}
130 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
130 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
131 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
131 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
132 ENABLE_SOUND=${ENABLE_SOUND:=true}
132 ENABLE_SOUND=${ENABLE_SOUND:=true}
133 ENABLE_DBUS=${ENABLE_DBUS:=true}
133 ENABLE_DBUS=${ENABLE_DBUS:=true}
134 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
134 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
135 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
135 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
136 ENABLE_XORG=${ENABLE_XORG:=false}
136 ENABLE_XORG=${ENABLE_XORG:=false}
137 ENABLE_WM=${ENABLE_WM:=""}
137 ENABLE_WM=${ENABLE_WM:=""}
138 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
138 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
139 ENABLE_USER=${ENABLE_USER:=true}
139 ENABLE_USER=${ENABLE_USER:=true}
140 USER_NAME=${USER_NAME:="pi"}
140 USER_NAME=${USER_NAME:="pi"}
141 ENABLE_ROOT=${ENABLE_ROOT:=false}
141 ENABLE_ROOT=${ENABLE_ROOT:=false}
142 ENABLE_QEMU=${ENABLE_QEMU:=false}
142 ENABLE_QEMU=${ENABLE_QEMU:=false}
143 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
143 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
144
144
145 # SSH settings
145 # SSH settings
146 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
146 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
147 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
147 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
148 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
148 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
149 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
149 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
150 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
150 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
151
151
152 # Advanced settings
152 # Advanced settings
153 ENABLE_SYSTEMDSWAP=${ENABLE_MINBASE:=false}
153 ENABLE_SYSTEMDSWAP=${ENABLE_MINBASE:=false}
154 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
154 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
155 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
155 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
156 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
156 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
157 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
157 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
158 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
158 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
159 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
159 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
160 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
160 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
161 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
161 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
162 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
162 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
163 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
163 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
164 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
164 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
165 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
165 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
166 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
166 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
167 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
167 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
168 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
168 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
169 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
169 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
170 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
170 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
171
171
172 # Kernel compilation settings
172 # Kernel compilation settings
173 BUILD_KERNEL=${BUILD_KERNEL:=true}
173 BUILD_KERNEL=${BUILD_KERNEL:=true}
174 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
174 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
175 KERNEL_THREADS=${KERNEL_THREADS:=1}
175 KERNEL_THREADS=${KERNEL_THREADS:=1}
176 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
176 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
177 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
177 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
178 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
178 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
179 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
179 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
180 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
180 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
181 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
181 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
182 KERNEL_VIRT=${KERNEL_VIRT:=false}
182 KERNEL_VIRT=${KERNEL_VIRT:=false}
183 KERNEL_BPF=${KERNEL_BPF:=false}
183 KERNEL_BPF=${KERNEL_BPF:=false}
184 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=POWERSAVE}
184 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=POWERSAVE}
185
185
186 # Kernel compilation from source directory settings
186 # Kernel compilation from source directory settings
187 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
187 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
188 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
188 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
189 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
189 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
190 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
190 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
191
191
192 # Reduce disk usage settings
192 # Reduce disk usage settings
193 REDUCE_APT=${REDUCE_APT:=true}
193 REDUCE_APT=${REDUCE_APT:=true}
194 REDUCE_DOC=${REDUCE_DOC:=true}
194 REDUCE_DOC=${REDUCE_DOC:=true}
195 REDUCE_MAN=${REDUCE_MAN:=true}
195 REDUCE_MAN=${REDUCE_MAN:=true}
196 REDUCE_VIM=${REDUCE_VIM:=false}
196 REDUCE_VIM=${REDUCE_VIM:=false}
197 REDUCE_BASH=${REDUCE_BASH:=false}
197 REDUCE_BASH=${REDUCE_BASH:=false}
198 REDUCE_HWDB=${REDUCE_HWDB:=true}
198 REDUCE_HWDB=${REDUCE_HWDB:=true}
199 REDUCE_SSHD=${REDUCE_SSHD:=true}
199 REDUCE_SSHD=${REDUCE_SSHD:=true}
200 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
200 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
201
201
202 # Encrypted filesystem settings
202 # Encrypted filesystem settings
203 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
203 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
204 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
204 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
205 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
205 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
206 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
206 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
207 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
207 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
208 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
208 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
209 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
209 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
210 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
210 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
211 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
211 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
212
212
213 # Chroot scripts directory
213 # Chroot scripts directory
214 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
214 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
215
215
216 # Packages required in the chroot build environment
216 # Packages required in the chroot build environment
217 APT_INCLUDES=${APT_INCLUDES:=""}
217 APT_INCLUDES=${APT_INCLUDES:=""}
218 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
218 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
219
219
220 #Packages to exclude from chroot build environment
220 #Packages to exclude from chroot build environment
221 APT_EXCLUDES=${APT_EXCLUDES:=""}
221 APT_EXCLUDES=${APT_EXCLUDES:=""}
222
222
223 # Packages required for bootstrapping
223 # Packages required for bootstrapping
224 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
224 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
225 MISSING_PACKAGES=""
225 MISSING_PACKAGES=""
226
226
227 # Packages installed for c/c++ build environment in chroot (keep empty)
227 # Packages installed for c/c++ build environment in chroot (keep empty)
228 COMPILER_PACKAGES=""
228 COMPILER_PACKAGES=""
229
229
230 #Check if apt-cacher-ng has port 3142 open and set APT_PROXY
230 #Check if apt-cacher-ng has port 3142 open and set APT_PROXY
231 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
231 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
232 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
232 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
233 APT_PROXY=http://127.0.0.1:3142/
233 APT_PROXY=http://127.0.0.1:3142/
234 fi
234 fi
235
235
236 #netselect-apt does not know buster yet
236 #netselect-apt does not know buster yet
237 if [ "$RELEASE" = "buster" ] ; then
237 if [ "$RELEASE" = "buster" ] ; then
238 RLS=testing
238 RLS=testing
239 else
239 else
240 RLS="$RELEASE"
240 RLS="$RELEASE"
241 fi
241 fi
242
242
243 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
243 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
244 rm "$(pwd)/files/apt/sources.list"
244 rm "$(pwd)/files/apt/sources.list"
245 fi
245 fi
246
246
247 if [ "$ENABLE_NONFREE" = true ] ; then
247 if [ "$ENABLE_NONFREE" = true ] ; then
248 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
248 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
249 else
249 else
250 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
250 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
251 fi
251 fi
252
252
253 #sed and cut the result string so we can use it as APT_SERVER
253 #sed and cut the result string so we can use it as APT_SERVER
254 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
254 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
255
255
256 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
256 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
257 if [ -n "$SET_ARCH" ] ; then
257 if [ -n "$SET_ARCH" ] ; then
258 # 64-bit configuration
258 # 64-bit configuration
259 if [ "$SET_ARCH" = 64 ] ; then
259 if [ "$SET_ARCH" = 64 ] ; then
260 # General 64-bit depended settings
260 # General 64-bit depended settings
261 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
261 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
262 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
262 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
263 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
263 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
264
264
265 # Raspberry Pi model specific settings
265 # Raspberry Pi model specific settings
266 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
266 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
268 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
268 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
269 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
269 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
270 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
270 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
271 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
271 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
272 else
272 else
273 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
273 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
274 exit 1
274 exit 1
275 fi
275 fi
276 fi
276 fi
277
277
278 # 32-bit configuration
278 # 32-bit configuration
279 if [ "$SET_ARCH" = 32 ] ; then
279 if [ "$SET_ARCH" = 32 ] ; then
280 # General 32-bit dependend settings
280 # General 32-bit dependend settings
281 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
281 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
282 KERNEL_ARCH=${KERNEL_ARCH:=arm}
282 KERNEL_ARCH=${KERNEL_ARCH:=arm}
283 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
283 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
284
284
285 # Raspberry Pi model specific settings
285 # Raspberry Pi model specific settings
286 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
286 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
287 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
287 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
288 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
288 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
289 RELEASE_ARCH=${RELEASE_ARCH:=armel}
289 RELEASE_ARCH=${RELEASE_ARCH:=armel}
290 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
290 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
291 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
291 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
292 fi
292 fi
293
293
294 # Raspberry Pi model specific settings
294 # Raspberry Pi model specific settings
295 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
295 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
296 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
296 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
297 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
297 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
298 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
298 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
299 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
299 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
300 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
300 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
301 fi
301 fi
302 fi
302 fi
303 #SET_ARCH not set
303 #SET_ARCH not set
304 else
304 else
305 echo "error: Please set '32' or '64' as value for SET_ARCH"
305 echo "error: Please set '32' or '64' as value for SET_ARCH"
306 exit 1
306 exit 1
307 fi
307 fi
308 # Device specific configuration and U-Boot configuration
308 # Device specific configuration and U-Boot configuration
309 case "$RPI_MODEL" in
309 case "$RPI_MODEL" in
310 0)
310 0)
311 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
311 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
312 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
312 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
313 ;;
313 ;;
314 1)
314 1)
315 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
315 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
316 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
316 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
317 ;;
317 ;;
318 1P)
318 1P)
319 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
319 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
321 ;;
321 ;;
322 2)
322 2)
323 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
323 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
325 ;;
325 ;;
326 3)
326 3)
327 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
327 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
329 ;;
329 ;;
330 3P)
330 3P)
331 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
331 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
333 ;;
333 ;;
334 *)
334 *)
335 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
335 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
336 exit 1
336 exit 1
337 ;;
337 ;;
338 esac
338 esac
339
339
340 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
340 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
341 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
341 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
342 # Include bluetooth packages on supported boards
342 # Include bluetooth packages on supported boards
343 if [ "$ENABLE_BLUETOOTH" = true ] && [ "$ENABLE_CONSOLE" = false ]; then
343 if [ "$ENABLE_BLUETOOTH" = true ] ; then
344 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
344 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
345 fi
345 fi
346 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
346 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
347 # Check if the internal wireless interface is not supported by the RPi model
347 # Check if the internal wireless interface is not supported by the RPi model
348 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
348 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
349 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
349 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
350 exit 1
350 exit 1
351 fi
351 fi
352 fi
352 fi
353
353
354 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
354 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
355 echo "error: You have to compile kernel sources, if you want to enable nexmon"
355 echo "error: You have to compile kernel sources, if you want to enable nexmon"
356 exit 1
356 exit 1
357 fi
357 fi
358
358
359 # Prepare date string for default image file name
359 # Prepare date string for default image file name
360 DATE="$(date +%Y-%m-%d)"
360 DATE="$(date +%Y-%m-%d)"
361 if [ -z "$KERNEL_BRANCH" ] ; then
361 if [ -z "$KERNEL_BRANCH" ] ; then
362 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
362 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
363 else
363 else
364 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
364 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
365 fi
365 fi
366
366
367 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
367 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
368 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
368 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
369 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
369 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
370 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
370 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
371 exit 1
371 exit 1
372 fi
372 fi
373 fi
373 fi
374
374
375 set +x
375 set +x
376
376
377 # Add cmake to compile videocore sources
377 # Add cmake to compile videocore sources
378 if [ "$ENABLE_VIDEOCORE" = true ] ; then
378 if [ "$ENABLE_VIDEOCORE" = true ] ; then
379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
380 fi
380 fi
381
381
382 # Add deps for nexmon
382 # Add deps for nexmon
383 if [ "$ENABLE_NEXMON" = true ] ; then
383 if [ "$ENABLE_NEXMON" = true ] ; then
384 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
384 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
385 fi
385 fi
386
386
387 # Add libncurses5 to enable kernel menuconfig
387 # Add libncurses5 to enable kernel menuconfig
388 if [ "$KERNEL_MENUCONFIG" = true ] ; then
388 if [ "$KERNEL_MENUCONFIG" = true ] ; then
389 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
389 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
390 fi
390 fi
391
391
392 # Add ccache compiler cache for (faster) kernel cross (re)compilation
392 # Add ccache compiler cache for (faster) kernel cross (re)compilation
393 if [ "$KERNEL_CCACHE" = true ] ; then
393 if [ "$KERNEL_CCACHE" = true ] ; then
394 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
394 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
395 fi
395 fi
396
396
397 # Add cryptsetup package to enable filesystem encryption
397 # Add cryptsetup package to enable filesystem encryption
398 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
398 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
399 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
399 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
400 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
400 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
401
401
402 #If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
402 #If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
403 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
403 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
404 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
404 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
405 fi
405 fi
406
406
407 if [ -z "$CRYPTFS_PASSWORD" ] ; then
407 if [ -z "$CRYPTFS_PASSWORD" ] ; then
408 echo "error: no password defined (CRYPTFS_PASSWORD)!"
408 echo "error: no password defined (CRYPTFS_PASSWORD)!"
409 exit 1
409 exit 1
410 fi
410 fi
411 ENABLE_INITRAMFS=true
411 ENABLE_INITRAMFS=true
412 fi
412 fi
413
413
414 # Add initramfs generation tools
414 # Add initramfs generation tools
415 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
415 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
416 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
416 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
417 fi
417 fi
418
418
419 # Add device-tree-compiler required for building the U-Boot bootloader
419 # Add device-tree-compiler required for building the U-Boot bootloader
420 if [ "$ENABLE_UBOOT" = true ] ; then
420 if [ "$ENABLE_UBOOT" = true ] ; then
421 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
421 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
422 else
422 else
423 if [ "$ENABLE_UBOOTUSB" = true ] ; then
423 if [ "$ENABLE_UBOOTUSB" = true ] ; then
424 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
424 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
425 exit 1
425 exit 1
426 fi
426 fi
427 fi
427 fi
428
428
429 if [ "$ENABLE_BLUETOOTH" = true ] ; then
430 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
431 if [ "$ENABLE_CONSOLE" = false ] ; then
432 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
433 fi
434 fi
435 fi
436
437 # Check if root SSH (v2) public key file exists
429 # Check if root SSH (v2) public key file exists
438 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
430 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
439 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
431 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
440 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
432 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
441 exit 1
433 exit 1
442 fi
434 fi
443 fi
435 fi
444
436
445 # Check if $USER_NAME SSH (v2) public key file exists
437 # Check if $USER_NAME SSH (v2) public key file exists
446 if [ -n "$SSH_USER_PUB_KEY" ] ; then
438 if [ -n "$SSH_USER_PUB_KEY" ] ; then
447 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
439 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
448 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
440 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
449 exit 1
441 exit 1
450 fi
442 fi
451 fi
443 fi
452
444
453 # Check if all required packages are installed on the build system
445 # Check if all required packages are installed on the build system
454 for package in $REQUIRED_PACKAGES ; do
446 for package in $REQUIRED_PACKAGES ; do
455 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
447 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
456 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
448 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
457 fi
449 fi
458 done
450 done
459
451
460 # If there are missing packages ask confirmation for install, or exit
452 # If there are missing packages ask confirmation for install, or exit
461 if [ -n "$MISSING_PACKAGES" ] ; then
453 if [ -n "$MISSING_PACKAGES" ] ; then
462 echo "the following packages needed by this script are not installed:"
454 echo "the following packages needed by this script are not installed:"
463 echo "$MISSING_PACKAGES"
455 echo "$MISSING_PACKAGES"
464
456
465 printf "\ndo you want to install the missing packages right now? [y/n] "
457 printf "\ndo you want to install the missing packages right now? [y/n] "
466 read -r confirm
458 read -r confirm
467 [ "$confirm" != "y" ] && exit 1
459 [ "$confirm" != "y" ] && exit 1
468
460
469 # Make sure all missing required packages are installed
461 # Make sure all missing required packages are installed
470 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
462 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
471 fi
463 fi
472
464
473 # Check if ./bootstrap.d directory exists
465 # Check if ./bootstrap.d directory exists
474 if [ ! -d "./bootstrap.d/" ] ; then
466 if [ ! -d "./bootstrap.d/" ] ; then
475 echo "error: './bootstrap.d' required directory not found!"
467 echo "error: './bootstrap.d' required directory not found!"
476 exit 1
468 exit 1
477 fi
469 fi
478
470
479 # Check if ./files directory exists
471 # Check if ./files directory exists
480 if [ ! -d "./files/" ] ; then
472 if [ ! -d "./files/" ] ; then
481 echo "error: './files' required directory not found!"
473 echo "error: './files' required directory not found!"
482 exit 1
474 exit 1
483 fi
475 fi
484
476
485 # Check if specified KERNELSRC_DIR directory exists
477 # Check if specified KERNELSRC_DIR directory exists
486 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
478 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
487 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
479 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
488 exit 1
480 exit 1
489 fi
481 fi
490
482
491 # Check if specified UBOOTSRC_DIR directory exists
483 # Check if specified UBOOTSRC_DIR directory exists
492 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
484 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
493 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
485 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
494 exit 1
486 exit 1
495 fi
487 fi
496
488
497 # Check if specified VIDEOCORESRC_DIR directory exists
489 # Check if specified VIDEOCORESRC_DIR directory exists
498 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
490 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
499 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
491 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
500 exit 1
492 exit 1
501 fi
493 fi
502
494
503 # Check if specified FBTURBOSRC_DIR directory exists
495 # Check if specified FBTURBOSRC_DIR directory exists
504 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
496 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
505 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
497 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
506 exit 1
498 exit 1
507 fi
499 fi
508
500
509 # Check if specified NEXMONSRC_DIR directory exists
501 # Check if specified NEXMONSRC_DIR directory exists
510 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
502 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
511 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
503 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
512 exit 1
504 exit 1
513 fi
505 fi
514
506
515 # Check if specified CHROOT_SCRIPTS directory exists
507 # Check if specified CHROOT_SCRIPTS directory exists
516 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
508 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
517 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
509 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
518 exit 1
510 exit 1
519 fi
511 fi
520
512
521 # Check if specified device mapping already exists (will be used by cryptsetup)
513 # Check if specified device mapping already exists (will be used by cryptsetup)
522 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
514 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
523 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
515 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
524 exit 1
516 exit 1
525 fi
517 fi
526
518
527 # Don't clobber an old build
519 # Don't clobber an old build
528 if [ -e "$BUILDDIR" ] ; then
520 if [ -e "$BUILDDIR" ] ; then
529 echo "error: directory ${BUILDDIR} already exists, not proceeding"
521 echo "error: directory ${BUILDDIR} already exists, not proceeding"
530 exit 1
522 exit 1
531 fi
523 fi
532
524
533 # Setup chroot directory
525 # Setup chroot directory
534 mkdir -p "${R}"
526 mkdir -p "${R}"
535
527
536 # Check if build directory has enough of free disk space >512MB
528 # Check if build directory has enough of free disk space >512MB
537 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
529 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
538 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
530 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
539 exit 1
531 exit 1
540 fi
532 fi
541
533
542 set -x
534 set -x
543
535
544 # Call "cleanup" function on various signals and errors
536 # Call "cleanup" function on various signals and errors
545 trap cleanup 0 1 2 3 6
537 trap cleanup 0 1 2 3 6
546
538
547 # Add required packages for the minbase installation
539 # Add required packages for the minbase installation
548 if [ "$ENABLE_MINBASE" = true ] ; then
540 if [ "$ENABLE_MINBASE" = true ] ; then
549 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
541 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
550 fi
542 fi
551
543
552 # Add parted package, required to get partprobe utility
544 # Add parted package, required to get partprobe utility
553 if [ "$EXPANDROOT" = true ] ; then
545 if [ "$EXPANDROOT" = true ] ; then
554 APT_INCLUDES="${APT_INCLUDES},parted"
546 APT_INCLUDES="${APT_INCLUDES},parted"
555 fi
547 fi
556
548
557 # Add dbus package, recommended if using systemd
549 # Add dbus package, recommended if using systemd
558 if [ "$ENABLE_DBUS" = true ] ; then
550 if [ "$ENABLE_DBUS" = true ] ; then
559 APT_INCLUDES="${APT_INCLUDES},dbus"
551 APT_INCLUDES="${APT_INCLUDES},dbus"
560 fi
552 fi
561
553
562 # Add iptables IPv4/IPv6 package
554 # Add iptables IPv4/IPv6 package
563 if [ "$ENABLE_IPTABLES" = true ] ; then
555 if [ "$ENABLE_IPTABLES" = true ] ; then
564 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
556 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
565 fi
557 fi
566
558
567 # Add openssh server package
559 # Add openssh server package
568 if [ "$ENABLE_SSHD" = true ] ; then
560 if [ "$ENABLE_SSHD" = true ] ; then
569 APT_INCLUDES="${APT_INCLUDES},openssh-server"
561 APT_INCLUDES="${APT_INCLUDES},openssh-server"
570 fi
562 fi
571
563
572 # Add alsa-utils package
564 # Add alsa-utils package
573 if [ "$ENABLE_SOUND" = true ] ; then
565 if [ "$ENABLE_SOUND" = true ] ; then
574 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
566 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
575 fi
567 fi
576
568
577 # Add rng-tools package
569 # Add rng-tools package
578 if [ "$ENABLE_HWRANDOM" = true ] ; then
570 if [ "$ENABLE_HWRANDOM" = true ] ; then
579 APT_INCLUDES="${APT_INCLUDES},rng-tools"
571 APT_INCLUDES="${APT_INCLUDES},rng-tools"
580 fi
572 fi
581
573
582 # Add fbturbo video driver
574 # Add fbturbo video driver
583 if [ "$ENABLE_FBTURBO" = true ] ; then
575 if [ "$ENABLE_FBTURBO" = true ] ; then
584 # Enable xorg package dependencies
576 # Enable xorg package dependencies
585 ENABLE_XORG=true
577 ENABLE_XORG=true
586 fi
578 fi
587
579
588 # Add user defined window manager package
580 # Add user defined window manager package
589 if [ -n "$ENABLE_WM" ] ; then
581 if [ -n "$ENABLE_WM" ] ; then
590 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
582 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
591
583
592 # Enable xorg package dependencies
584 # Enable xorg package dependencies
593 ENABLE_XORG=true
585 ENABLE_XORG=true
594 fi
586 fi
595
587
596 # Add xorg package
588 # Add xorg package
597 if [ "$ENABLE_XORG" = true ] ; then
589 if [ "$ENABLE_XORG" = true ] ; then
598 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
590 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
599 fi
591 fi
600
592
601 # Replace selected packages with smaller clones
593 # Replace selected packages with smaller clones
602 if [ "$ENABLE_REDUCE" = true ] ; then
594 if [ "$ENABLE_REDUCE" = true ] ; then
603 # Add levee package instead of vim-tiny
595 # Add levee package instead of vim-tiny
604 if [ "$REDUCE_VIM" = true ] ; then
596 if [ "$REDUCE_VIM" = true ] ; then
605 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
597 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
606 fi
598 fi
607
599
608 # Add dropbear package instead of openssh-server
600 # Add dropbear package instead of openssh-server
609 if [ "$REDUCE_SSHD" = true ] ; then
601 if [ "$REDUCE_SSHD" = true ] ; then
610 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
602 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
611 fi
603 fi
612 fi
604 fi
613
605
614 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
606 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
615 if [ "$ENABLE_SYSVINIT" = false ] ; then
607 if [ "$ENABLE_SYSVINIT" = false ] ; then
616 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
608 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
617 fi
609 fi
618
610
619 # Configure kernel sources if no KERNELSRC_DIR
611 # Configure kernel sources if no KERNELSRC_DIR
620 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
612 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
621 KERNELSRC_CONFIG=true
613 KERNELSRC_CONFIG=true
622 fi
614 fi
623
615
624 # Configure reduced kernel
616 # Configure reduced kernel
625 if [ "$KERNEL_REDUCE" = true ] ; then
617 if [ "$KERNEL_REDUCE" = true ] ; then
626 KERNELSRC_CONFIG=false
618 KERNELSRC_CONFIG=false
627 fi
619 fi
628
620
629 # Configure qemu compatible kernel
621 # Configure qemu compatible kernel
630 if [ "$ENABLE_QEMU" = true ] ; then
622 if [ "$ENABLE_QEMU" = true ] ; then
631 DTB_FILE=vexpress-v2p-ca15_a7.dtb
623 DTB_FILE=vexpress-v2p-ca15_a7.dtb
632 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
624 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
633 KERNEL_DEFCONFIG="vexpress_defconfig"
625 KERNEL_DEFCONFIG="vexpress_defconfig"
634 if [ "$KERNEL_MENUCONFIG" = false ] ; then
626 if [ "$KERNEL_MENUCONFIG" = false ] ; then
635 KERNEL_OLDDEFCONFIG=true
627 KERNEL_OLDDEFCONFIG=true
636 fi
628 fi
637 fi
629 fi
638
630
639 # Execute bootstrap scripts
631 # Execute bootstrap scripts
640 for SCRIPT in bootstrap.d/*.sh; do
632 for SCRIPT in bootstrap.d/*.sh; do
641 head -n 3 "$SCRIPT"
633 head -n 3 "$SCRIPT"
642 . "$SCRIPT"
634 . "$SCRIPT"
643 done
635 done
644
636
645 ## Execute custom bootstrap scripts
637 ## Execute custom bootstrap scripts
646 if [ -d "custom.d" ] ; then
638 if [ -d "custom.d" ] ; then
647 for SCRIPT in custom.d/*.sh; do
639 for SCRIPT in custom.d/*.sh; do
648 . "$SCRIPT"
640 . "$SCRIPT"
649 done
641 done
650 fi
642 fi
651
643
652 # Execute custom scripts inside the chroot
644 # Execute custom scripts inside the chroot
653 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
645 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
654 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
646 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
655 chroot_exec /bin/bash -x <<'EOF'
647 chroot_exec /bin/bash -x <<'EOF'
656 for SCRIPT in /chroot_scripts/* ; do
648 for SCRIPT in /chroot_scripts/* ; do
657 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
649 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
658 $SCRIPT
650 $SCRIPT
659 fi
651 fi
660 done
652 done
661 EOF
653 EOF
662 rm -rf "${R}/chroot_scripts"
654 rm -rf "${R}/chroot_scripts"
663 fi
655 fi
664
656
665 # Remove c/c++ build environment from the chroot
657 # Remove c/c++ build environment from the chroot
666 chroot_remove_cc
658 chroot_remove_cc
667
659
668 # Generate required machine-id
660 # Generate required machine-id
669 MACHINE_ID=$(dbus-uuidgen)
661 MACHINE_ID=$(dbus-uuidgen)
670 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
662 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
671 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
663 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
672
664
673 # APT Cleanup
665 # APT Cleanup
674 chroot_exec apt-get -y clean
666 chroot_exec apt-get -y clean
675 chroot_exec apt-get -y autoclean
667 chroot_exec apt-get -y autoclean
676 chroot_exec apt-get -y autoremove
668 chroot_exec apt-get -y autoremove
677
669
678 # Unmount mounted filesystems
670 # Unmount mounted filesystems
679 umount -l "${R}/proc"
671 umount -l "${R}/proc"
680 umount -l "${R}/sys"
672 umount -l "${R}/sys"
681
673
682 # Clean up directories
674 # Clean up directories
683 rm -rf "${R}/run/*"
675 rm -rf "${R}/run/*"
684 rm -rf "${R}/tmp/*"
676 rm -rf "${R}/tmp/*"
685
677
686 # Clean up files
678 # Clean up files
687 rm -f "${ETC_DIR}/ssh/ssh_host_*"
679 rm -f "${ETC_DIR}/ssh/ssh_host_*"
688 rm -f "${ETC_DIR}/dropbear/dropbear_*"
680 rm -f "${ETC_DIR}/dropbear/dropbear_*"
689 rm -f "${ETC_DIR}/apt/sources.list.save"
681 rm -f "${ETC_DIR}/apt/sources.list.save"
690 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
682 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
691 rm -f "${ETC_DIR}/*-"
683 rm -f "${ETC_DIR}/*-"
692 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
684 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
693 rm -f "${ETC_DIR}/resolv.conf"
685 rm -f "${ETC_DIR}/resolv.conf"
694 rm -f "${R}/root/.bash_history"
686 rm -f "${R}/root/.bash_history"
695 rm -f "${R}/var/lib/urandom/random-seed"
687 rm -f "${R}/var/lib/urandom/random-seed"
696 rm -f "${R}/initrd.img"
688 rm -f "${R}/initrd.img"
697 rm -f "${R}/vmlinuz"
689 rm -f "${R}/vmlinuz"
698 rm -f "${R}${QEMU_BINARY}"
690 rm -f "${R}${QEMU_BINARY}"
699
691
700 if [ "$ENABLE_QEMU" = true ] ; then
692 if [ "$ENABLE_QEMU" = true ] ; then
701 # Setup QEMU directory
693 # Setup QEMU directory
702 mkdir "${BASEDIR}/qemu"
694 mkdir "${BASEDIR}/qemu"
703
695
704 # Copy kernel image to QEMU directory
696 # Copy kernel image to QEMU directory
705 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
697 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
706
698
707 # Copy kernel config to QEMU directory
699 # Copy kernel config to QEMU directory
708 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
700 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
709
701
710 # Copy kernel dtbs to QEMU directory
702 # Copy kernel dtbs to QEMU directory
711 for dtb in "${BOOT_DIR}/"*.dtb ; do
703 for dtb in "${BOOT_DIR}/"*.dtb ; do
712 if [ -f "${dtb}" ] ; then
704 if [ -f "${dtb}" ] ; then
713 install_readonly "${dtb}" "${BASEDIR}/qemu/"
705 install_readonly "${dtb}" "${BASEDIR}/qemu/"
714 fi
706 fi
715 done
707 done
716
708
717 # Copy kernel overlays to QEMU directory
709 # Copy kernel overlays to QEMU directory
718 if [ -d "${BOOT_DIR}/overlays" ] ; then
710 if [ -d "${BOOT_DIR}/overlays" ] ; then
719 # Setup overlays dtbs directory
711 # Setup overlays dtbs directory
720 mkdir "${BASEDIR}/qemu/overlays"
712 mkdir "${BASEDIR}/qemu/overlays"
721
713
722 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
714 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
723 if [ -f "${dtb}" ] ; then
715 if [ -f "${dtb}" ] ; then
724 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
716 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
725 fi
717 fi
726 done
718 done
727 fi
719 fi
728
720
729 # Copy u-boot files to QEMU directory
721 # Copy u-boot files to QEMU directory
730 if [ "$ENABLE_UBOOT" = true ] ; then
722 if [ "$ENABLE_UBOOT" = true ] ; then
731 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
723 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
732 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
724 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
733 fi
725 fi
734 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
726 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
735 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
727 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
736 fi
728 fi
737 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
729 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
738 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
730 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
739 fi
731 fi
740 fi
732 fi
741
733
742 # Copy initramfs to QEMU directory
734 # Copy initramfs to QEMU directory
743 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
735 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
744 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
736 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
745 fi
737 fi
746 fi
738 fi
747
739
748 # Calculate size of the chroot directory in KB
740 # Calculate size of the chroot directory in KB
749 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
741 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
750
742
751 # Calculate the amount of needed 512 Byte sectors
743 # Calculate the amount of needed 512 Byte sectors
752 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
744 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
753 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
745 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
754 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
746 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
755
747
756 # The root partition is EXT4
748 # The root partition is EXT4
757 # This means more space than the actual used space of the chroot is used.
749 # This means more space than the actual used space of the chroot is used.
758 # As overhead for journaling and reserved blocks 35% are added.
750 # As overhead for journaling and reserved blocks 35% are added.
759 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
751 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
760
752
761 # Calculate required image size in 512 Byte sectors
753 # Calculate required image size in 512 Byte sectors
762 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
754 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
763
755
764 # Prepare image file
756 # Prepare image file
765 if [ "$ENABLE_SPLITFS" = true ] ; then
757 if [ "$ENABLE_SPLITFS" = true ] ; then
766 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
758 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
767 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
759 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
768 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
760 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
769 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
761 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
770
762
771 # Write firmware/boot partition tables
763 # Write firmware/boot partition tables
772 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
764 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
773 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
765 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
774 EOM
766 EOM
775
767
776 # Write root partition table
768 # Write root partition table
777 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
769 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
778 ${TABLE_SECTORS},${ROOT_SECTORS},83
770 ${TABLE_SECTORS},${ROOT_SECTORS},83
779 EOM
771 EOM
780
772
781 # Setup temporary loop devices
773 # Setup temporary loop devices
782 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
774 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
783 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
775 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
784 else # ENABLE_SPLITFS=false
776 else # ENABLE_SPLITFS=false
785 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
777 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
786 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
778 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
787
779
788 # Write partition table
780 # Write partition table
789 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
781 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
790 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
782 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
791 ${ROOT_OFFSET},${ROOT_SECTORS},83
783 ${ROOT_OFFSET},${ROOT_SECTORS},83
792 EOM
784 EOM
793
785
794 # Setup temporary loop devices
786 # Setup temporary loop devices
795 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
787 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
796 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
788 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
797 fi
789 fi
798
790
799 if [ "$ENABLE_CRYPTFS" = true ] ; then
791 if [ "$ENABLE_CRYPTFS" = true ] ; then
800 # Create dummy ext4 fs
792 # Create dummy ext4 fs
801 mkfs.ext4 "$ROOT_LOOP"
793 mkfs.ext4 "$ROOT_LOOP"
802
794
803 # Setup password keyfile
795 # Setup password keyfile
804 touch .password
796 touch .password
805 chmod 600 .password
797 chmod 600 .password
806 echo -n ${CRYPTFS_PASSWORD} > .password
798 echo -n ${CRYPTFS_PASSWORD} > .password
807
799
808 # Initialize encrypted partition
800 # Initialize encrypted partition
809 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
801 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
810
802
811 # Open encrypted partition and setup mapping
803 # Open encrypted partition and setup mapping
812 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
804 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
813
805
814 # Secure delete password keyfile
806 # Secure delete password keyfile
815 shred -zu .password
807 shred -zu .password
816
808
817 # Update temporary loop device
809 # Update temporary loop device
818 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
810 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
819
811
820 # Wipe encrypted partition (encryption cipher is used for randomness)
812 # Wipe encrypted partition (encryption cipher is used for randomness)
821 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
813 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
822 fi
814 fi
823
815
824 # Build filesystems
816 # Build filesystems
825 mkfs.vfat "$FRMW_LOOP"
817 mkfs.vfat "$FRMW_LOOP"
826 mkfs.ext4 "$ROOT_LOOP"
818 mkfs.ext4 "$ROOT_LOOP"
827
819
828 # Mount the temporary loop devices
820 # Mount the temporary loop devices
829 mkdir -p "$BUILDDIR/mount"
821 mkdir -p "$BUILDDIR/mount"
830 mount "$ROOT_LOOP" "$BUILDDIR/mount"
822 mount "$ROOT_LOOP" "$BUILDDIR/mount"
831
823
832 mkdir -p "$BUILDDIR/mount/boot/firmware"
824 mkdir -p "$BUILDDIR/mount/boot/firmware"
833 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
825 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
834
826
835 # Copy all files from the chroot to the loop device mount point directory
827 # Copy all files from the chroot to the loop device mount point directory
836 rsync -a "${R}/" "$BUILDDIR/mount/"
828 rsync -a "${R}/" "$BUILDDIR/mount/"
837
829
838 # Unmount all temporary loop devices and mount points
830 # Unmount all temporary loop devices and mount points
839 cleanup
831 cleanup
840
832
841 # Create block map file(s) of image(s)
833 # Create block map file(s) of image(s)
842 if [ "$ENABLE_SPLITFS" = true ] ; then
834 if [ "$ENABLE_SPLITFS" = true ] ; then
843 # Create block map files for "bmaptool"
835 # Create block map files for "bmaptool"
844 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
836 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
845 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
837 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
846
838
847 # Image was successfully created
839 # Image was successfully created
848 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
840 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
849 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
841 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
850 else
842 else
851 # Create block map file for "bmaptool"
843 # Create block map file for "bmaptool"
852 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
844 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
853
845
854 # Image was successfully created
846 # Image was successfully created
855 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
847 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
856
848
857 # Create qemu qcow2 image
849 # Create qemu qcow2 image
858 if [ "$ENABLE_QEMU" = true ] ; then
850 if [ "$ENABLE_QEMU" = true ] ; then
859 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
851 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
860 QEMU_SIZE=16G
852 QEMU_SIZE=16G
861
853
862 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
854 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
863 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
855 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
864
856
865 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
857 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
866 fi
858 fi
867 fi
859 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant